com.io7m.jcanephora.core

## Enum JCGLType

- java.lang.Object
- - java.lang.Enum<JCGLType>
  - - com.io7m.jcanephora.core.JCGLType

- All Implemented Interfaces:
    Serializable, Comparable<JCGLType>

      public enum JCGLType
      extends Enum<JCGLType>

  Type-safe OpenGL shader types.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `TYPE_BOOLEAN` GLSL boolean type.
    `TYPE_BOOLEAN_VECTOR_2` GLSL boolean vector type.
    `TYPE_BOOLEAN_VECTOR_3` GLSL boolean vector type.
    `TYPE_BOOLEAN_VECTOR_4` GLSL boolean vector type.
    `TYPE_FLOAT` GLSL floating-point type.
    `TYPE_FLOAT_MATRIX_2` GLSL 2x2 floating-point matrix type.
    `TYPE_FLOAT_MATRIX_2x3` GLSL 2x3 float matrix type.
    `TYPE_FLOAT_MATRIX_2x4` GLSL 2x4 float matrix type.
    `TYPE_FLOAT_MATRIX_3` GLSL 3x3 floating-point matrix type.
    `TYPE_FLOAT_MATRIX_3x2` GLSL 3x2 float matrix type.
    `TYPE_FLOAT_MATRIX_3x4` GLSL 3x4 float matrix type.
    `TYPE_FLOAT_MATRIX_4` GLSL 4x4 floating-point matrix type.
    `TYPE_FLOAT_MATRIX_4x2` GLSL 4x2 float matrix type.
    `TYPE_FLOAT_MATRIX_4x3` GLSL 4x3 float matrix type.
    `TYPE_FLOAT_VECTOR_2` GLSL floating-point vector type.
    `TYPE_FLOAT_VECTOR_3` GLSL floating-point vector type.
    `TYPE_FLOAT_VECTOR_4` GLSL floating-point vector type.
    `TYPE_INTEGER` GLSL integer type.
    `TYPE_INTEGER_VECTOR_2` GLSL integer vector type.
    `TYPE_INTEGER_VECTOR_3` GLSL integer vector type.
    `TYPE_INTEGER_VECTOR_4` GLSL integer vector type.
    `TYPE_SAMPLER_2D` GLSL 2D sampler type.
    `TYPE_SAMPLER_3D` GLSL 3D sampler type.
    `TYPE_SAMPLER_CUBE` GLSL cube sampler type.
    `TYPE_UNSIGNED_INTEGER` GLSL unsigned integer type.
    `TYPE_UNSIGNED_INTEGER_VECTOR_2` GLSL unsigned integer vector type.
    `TYPE_UNSIGNED_INTEGER_VECTOR_3` GLSL unsigned integer vector type.
    `TYPE_UNSIGNED_INTEGER_VECTOR_4` GLSL unsigned integer vector type.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static JCGLType` | `fromName(String name)`
    `int` | `getElementCount()`
    `String` | `getName()`
    `boolean` | `isFloatingPointType()`
    `boolean` | `isSamplerType()`
    `static JCGLType` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static JCGLType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### TYPE_BOOLEAN

          public static final JCGLType TYPE_BOOLEAN

      GLSL boolean type.

    - #### TYPE_BOOLEAN_VECTOR_2

          public static final JCGLType TYPE_BOOLEAN_VECTOR_2

      GLSL boolean vector type.

    - #### TYPE_BOOLEAN_VECTOR_3

          public static final JCGLType TYPE_BOOLEAN_VECTOR_3

      GLSL boolean vector type.

    - #### TYPE_BOOLEAN_VECTOR_4

          public static final JCGLType TYPE_BOOLEAN_VECTOR_4

      GLSL boolean vector type.

    - #### TYPE_FLOAT

          public static final JCGLType TYPE_FLOAT

      GLSL floating-point type.

    - #### TYPE_FLOAT_MATRIX_2

          public static final JCGLType TYPE_FLOAT_MATRIX_2

      GLSL 2x2 floating-point matrix type.

    - #### TYPE_FLOAT_MATRIX_3

          public static final JCGLType TYPE_FLOAT_MATRIX_3

      GLSL 3x3 floating-point matrix type.

    - #### TYPE_FLOAT_MATRIX_4

          public static final JCGLType TYPE_FLOAT_MATRIX_4

      GLSL 4x4 floating-point matrix type.

    - #### TYPE_FLOAT_VECTOR_2

          public static final JCGLType TYPE_FLOAT_VECTOR_2

      GLSL floating-point vector type.

    - #### TYPE_FLOAT_VECTOR_3

          public static final JCGLType TYPE_FLOAT_VECTOR_3

      GLSL floating-point vector type.

    - #### TYPE_FLOAT_VECTOR_4

          public static final JCGLType TYPE_FLOAT_VECTOR_4

      GLSL floating-point vector type.

    - #### TYPE_INTEGER

          public static final JCGLType TYPE_INTEGER

      GLSL integer type.

    - #### TYPE_INTEGER_VECTOR_2

          public static final JCGLType TYPE_INTEGER_VECTOR_2

      GLSL integer vector type.

    - #### TYPE_INTEGER_VECTOR_3

          public static final JCGLType TYPE_INTEGER_VECTOR_3

      GLSL integer vector type.

    - #### TYPE_INTEGER_VECTOR_4

          public static final JCGLType TYPE_INTEGER_VECTOR_4

      GLSL integer vector type.

    - #### TYPE_SAMPLER_2D

          public static final JCGLType TYPE_SAMPLER_2D

      GLSL 2D sampler type.

    - #### TYPE_SAMPLER_3D

          public static final JCGLType TYPE_SAMPLER_3D

      GLSL 3D sampler type.

    - #### TYPE_SAMPLER_CUBE

          public static final JCGLType TYPE_SAMPLER_CUBE

      GLSL cube sampler type.

    - #### TYPE_UNSIGNED_INTEGER

          public static final JCGLType TYPE_UNSIGNED_INTEGER

      GLSL unsigned integer type.

    - #### TYPE_UNSIGNED_INTEGER_VECTOR_2

          public static final JCGLType TYPE_UNSIGNED_INTEGER_VECTOR_2

      GLSL unsigned integer vector type.

    - #### TYPE_UNSIGNED_INTEGER_VECTOR_3

          public static final JCGLType TYPE_UNSIGNED_INTEGER_VECTOR_3

      GLSL unsigned integer vector type.

    - #### TYPE_UNSIGNED_INTEGER_VECTOR_4

          public static final JCGLType TYPE_UNSIGNED_INTEGER_VECTOR_4

      GLSL unsigned integer vector type.

    - #### TYPE_FLOAT_MATRIX_4x3

          public static final JCGLType TYPE_FLOAT_MATRIX_4x3

      GLSL 4x3 float matrix type.

    - #### TYPE_FLOAT_MATRIX_4x2

          public static final JCGLType TYPE_FLOAT_MATRIX_4x2

      GLSL 4x2 float matrix type.

    - #### TYPE_FLOAT_MATRIX_3x4

          public static final JCGLType TYPE_FLOAT_MATRIX_3x4

      GLSL 3x4 float matrix type.

    - #### TYPE_FLOAT_MATRIX_3x2

          public static final JCGLType TYPE_FLOAT_MATRIX_3x2

      GLSL 3x2 float matrix type.

    - #### TYPE_FLOAT_MATRIX_2x4

          public static final JCGLType TYPE_FLOAT_MATRIX_2x4

      GLSL 2x4 float matrix type.

    - #### TYPE_FLOAT_MATRIX_2x3

          public static final JCGLType TYPE_FLOAT_MATRIX_2x3

      GLSL 2x3 float matrix type.

  - ### Method Detail

    - #### values

          public static JCGLType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (JCGLType c : JCGLType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static JCGLType valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### fromName

          public static JCGLType fromName(String name)
                                   throws NoSuchElementException

      Parameters:
        `name` - The name of the type.
      Returns:
        The type corresponding to the given type name as it appears in a GLSL program.
      Throws:
        `NoSuchElementException` - If the type is unknown.

    - #### getName

          public String getName()

      Returns:
        The name of the type.

    - #### isSamplerType

          public boolean isSamplerType()

      Returns:
        `true` if the current type is a sampler type.

    - #### isFloatingPointType

          public boolean isFloatingPointType()

      Returns:
        `true` if the current type is a floating point type.

    - #### getElementCount

          public int getElementCount()

      Returns:
        The number of scalar elements that the current type implies

Copyright © 2016 <code@io7m.com> http://io7m.com